<?php

namespace BitCommunism\Doctrine;

use function DI\add;
use DI\Definition\EntryReference;

if (!function_exists(__NAMESPACE__ . '\\connections')) {
    /**
     * @param $connections
     * @return array
     */
    function connections($connections) {
        $connectionNames = [];

        $entityPaths = [];
        $connectionInfos = [];

        foreach ($connections as $name => $connection) {
            $connectionNames[] = $name;

            $entityPaths['doctrine.entity-paths.' . $name] = $connection['entity-paths'] instanceof EntryReference ? $connection['entity-paths'] : add($connection['entity-paths'] ?? []);
            $entityPaths['doctrine.connection.' . $name] = $connection['connection'] instanceof EntryReference ? $connection['connection'] : add($connection['connection'] ?? []);
        }


        return array_merge(
            [
                'doctrine.connections' => add($connectionNames),
            ],
            $entityPaths,
            $connectionInfos
        );
    }
}